/*************************************************************/
/*  lwormb.c, lwormw.c,   Version 1.14                       */
/*                                                           */
/*  By: Stefan Spaennare, Email: stefans@astro.lu.se         */
/*  BASIC version: Autumn 1985                               */
/*  C version:     January 2000                              */
/*  Latest update: 2002-05-07                                */
/*                                                           */
/*************************************************************/

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <graphics.h>
#include <conio.h>

double pi=3.14159265358979323;

long x,y,x1,y1;
long cx,cy,d,n,ls;
long i,col;
long candy_size,candy_counter;
long shot_counter,distance_counter;
long step_delay,laser_delay;
long border_col,worm_col,laser_col;
long candy_col,candy_old_col;
long text_col,background_col;

double skill,rrr;

char sss[80];

int xv[10001];
int yv[10001];

void start_sound()
{
   sound(500);
   delay(75);
   sound(1000);
   delay(75);
   sound(1500);
   delay(75);
   nosound();
} /* start_sound */

void candy_sound()
{
   sound(1000);
   delay(50);
   nosound();
} /* candy_sound */

void laser_sound()
{
   sound(2000);
   delay(2*laser_delay);
   nosound();
} /* laser_sound */

void hit_sound()
{
   sound(300);
   delay(100);
   sound(200);
   delay(100);
   sound(100);
   delay(100);
   nosound();
} /* hit_sound */


void init()
{
   rrr=1.0/(double)(RAND_MAX);

   x=320;
   y=240;
   x1=1;
   y1=0;

   d=1;
   n=2;
   ls=4;

   candy_counter=-1;
   shot_counter=0;
   distance_counter=0;

   candy_size=24;

   background_col=0;
   laser_col=4;
   border_col=5;
   worm_col=4;
   candy_col=9;
   candy_old_col=2;
   text_col=4;

   step_delay=8; /* ms */
   laser_delay=16; /* ms */

   cx=(long)((637.0-(double)(candy_size))*rrr*rand()+1.0);
   cy=(long)((464.0-(double)(candy_size))*rrr*rand()+15.0);

} /* init */


void empty()
{
  int j;

   setcolor(background_col);
   for (j=0; j<=639; j++) {
      line(j,0,j,479);
   } /* for j */

} /* empty */


void text_empty()
{
  int j;

   setcolor(background_col);

   for (j=1; j<=14; j++) {
      line(1,j,638,j);
   } /* for j */

} /* text_empty */

void hit_empty()
{
  int j;

  setcolor(background_col);

  for (j=180; j<=269; j++) {
     line(210,j,419,j);
  } /* for j */

} /* hit_empty */

void hit_border()
{
   setcolor(border_col);

   line(210,180,419,180);
   line(419,180,419,269);
   line(419,269,210,269);
   line(210,269,210,180);

} /* hit_border */

void start_border()
{
   setcolor(border_col);

   line(210,190,419,190);
   line(419,190,419,259);
   line(419,259,210,259);
   line(210,259,210,190);

   line(0,0,639,0);
   line(639,0,639,479);
   line(639,479,0,479);
   line(0,479,0,0);

} /* start_border */

void print_text()
{
   text_empty();

   setcolor(text_col);
   sprintf(sss,"Candy: %8ld",candy_counter);
   outtextxy(20,6,sss);
   sprintf(sss,"Shots: %8ld",shot_counter);
   outtextxy(220,6,sss);
   sprintf(sss,"Distance: %8ld",distance_counter);
   outtextxy(420,6,sss);

} /* print_text */



void border()
{
   print_text();

   setcolor(border_col);

   line(0,0,639,0);
   line(639,0,639,479);
   line(639,479,0,479);
   line(0,479,0,0);

   line(0,15,639,15);

} /* border */

void start()
{

   start_border();

   setcolor(text_col);
   outtextxy(220,200,"Laser Worm version 1.14");
   outtextxy(220,220,"Steer with s and l");
   outtextxy(220,240,"Laser with space");

   start_sound();

} /* start */

void candy()
{
   int j;

   setcolor(candy_old_col);

   for (j=cx; j<=(cx+candy_size); j++) {
      line(j,cy,j,cy+candy_size);
   } /* for j */

   cx=(long)((637.0-(double)(candy_size))*rrr*rand()+1.0);
   cy=(long)((464.0-(double)(candy_size))*rrr*rand()+15.0);

   setcolor(candy_col);

   for (j=cx; j<=(cx+candy_size); j++) {
      line(j,cy,j,cy+candy_size);
   } /* for j */

   candy_counter=candy_counter+1;

   print_text();

   candy_sound();

} /* candy */


void laser()
{
   shot_counter=shot_counter+1;

   print_text();

   if (x1 >= 1) {
      for (i=(x+1); i<=(638-ls); i=i+ls) {
	 if (getpixel(i,y) == candy_col) {
	    candy();
	 } /* if */
	 putpixel(i,y,laser_col);
      } /* for i */
      delay(laser_delay);
      i=i-ls;
      setcolor(background_col);
      line(i,y,x+1,y);
   } /* if */

   if (x1 <= -1) {
      for (i=(x-1); i>=(1+ls); i=i-ls) {
	 if (getpixel(i,y) == candy_col) {
	    candy();
	 } /* if */
	 putpixel(i,y,laser_col);
      } /* for i */
      delay(laser_delay);
      i=i+ls;
      setcolor(background_col);
      line(i,y,x-1,y);
   } /* if */

   if (y1 >= 1) {
      for (i=(y+1); i<=(478-ls); i=i+ls) {
	 if (getpixel(x,i) == candy_col) {
	    candy();
	 } /* if */
	 putpixel(x,i,laser_col);
      } /* for i */
      delay(laser_delay);
      i=i-ls;
      setcolor(background_col);
      line(x,i,x,y+1);
   } /* if */

   if (y1 <= -1) {
      for (i=(y-1); i >=(14+ls); i=i-ls) {
	 if (getpixel(x,i) == candy_col) {
	    candy();
	 } /* if */
	 putpixel(x,i,laser_col);
      } /* for */
      delay(laser_delay);
      i=i+ls;
      setcolor(background_col);
      line(x,i,x,y-1);
   } /* if */

   laser_sound();

} /* laser */


void hit()
{
  double t;

     print_text();

     if ((distance_counter == 0) || (shot_counter == 0)) {
	skill=0.0;
     }
     else {
	t=(double)(candy_counter);
	skill=15.0*t*t*t/
	((double)(distance_counter)*(double)(shot_counter));
     } /* if */

     hit_empty();
     hit_border();

     setcolor(text_col);
     sprintf(sss,"Candy points:    %6ld",candy_counter);
     outtextxy(220,190,sss);
     sprintf(sss,"Distance points: %6ld",distance_counter);
     outtextxy(220,210,sss);
     sprintf(sss,"Running skill:   %6.2f",skill);
     outtextxy(220,230,sss);

     hit_sound();

} /* hit */


void main()
{
   int gdriver = DETECT, gmode, errorcode;

   long quiti,flag,j;

   char cc;

   clrscr();

   initgraph(&gdriver,&gmode, "");

   errorcode = graphresult();

   randomize();

   cc='y';

   flag=0;

while (cc != 'n') {

   init();
   empty();
   start();

   for (j=1; j<=10000; j++) {
     xv[j]=0;
     yv[j]=0;
   } /* for j */

   cc=getch();

   empty();
   border();
   candy();

   d=1;
   xv[d]=x;
   yv[d]=y;

   cc=getch();

   while (flag == 0) {

      if (kbhit()) {
	 cc=getch();
	 if (cc == ' ') {
	    laser();
	 }
	 else if (cc == 's') {
	    if (y1 == 0) {
	       y1=-x1;
	       x1=0;
	    }
	    else {
	       x1=y1;
	       y1=0;
	    } /* if */
	 }
	 else if (cc == 'l') {
	    if (y1 == 0) {
	       y1=x1;
	       x1=0;
	    }
	    else {
	       x1=-y1;
	       y1=0;
	    } /* if */
	 } /* if */

      } /* if */

	 x=x+x1;
	 y=y+y1;

	 if ((xv[d] != 0) && (yv[d] !=0)) {
	    putpixel(xv[d],yv[d],background_col);
	 } /* if */

	 xv[d]=x;
	 yv[d]=y;

	 d=d+1;
	 if (d == n) {
	    d=1;
	    n=n+1+n/10;
	    print_text();
	 } /* if */

	 if ((d % 10) == 0) {
	    if ((rrr*rand()) < 0.002) {
	       candy_counter=candy_counter-1;
	       candy();
	    } /* if */
	 } /* if */

	 col=getpixel(x,y);

	 if (col != background_col) {
	    hit();
	    flag=1;
	 }
	 else {
	    putpixel(x,y,worm_col);
	    distance_counter=distance_counter+1;
	    delay(step_delay);
	 } /* if */

     } /* while */

     setcolor(text_col);
     outtextxy(220,250,"New game (y/n)?");

     do {
	cc=getch();
	flag=0;
     } while ((cc != 'y') && (cc != 'n'));

   } /* while */

   closegraph();

} /* End  */